/**
 * Created by janis dähne.
 */


interface Note extends Entity {

  text: string
  /**
   * when (re)named with as ...
   */
  alias: string | null

  /**
   * can point to a relation/link so not an entity
   */
  forRelationId: number | null
}


interface PointingNote extends Entity {
  text: string
  pointsTo: string
  pointingDirection: PointingDirection
}