/**
 * Created by janis dähne.
 */

class PointingNoteBuilder {

  static createPointingNote(text: string,
                            pointsTo: string,
                            pointingDirection: PointingDirection): PointingNote {
    return {
      text,
      pointsTo,
      pointingDirection
    }
  }

  static setText(target: PointingNote, text: string): PointingNote {
    target.text = text
    return target
  }

  static setPointsTo(target: PointingNote, pointsTo: string): PointingNote {
    target.pointsTo = pointsTo
    return target
  }

  static setAlias(target: PointingNote, pointingDirection: PointingDirection): PointingNote {
    target.pointingDirection = pointingDirection
    return target
  }
}