/**
 * Created by janis dähne.
 */

//only for the new parser
// more links/relations
const testsOk0: string[] = [
  `x #-- x`,
  `x #.. x`,
  `x --# x`,
  `x ..# x`,
  `x x-- x`,
  `x x.. x`,
  `x --x x`,
  `x ..x x`,
  `x }-- x`,
  `x }.. x`,
  `x --{ x`,
  `x ..{ x`,
  `x +-- x`,
  `x +.. x`,
  `x --+ x`,
  `x ..+ x`,
  `x ^-- x`,
  `x ^.. x`,
  `x --^ x`,
  `x ..^ x`,
]


//links/relations
const testsOk: string[] = [
  ``,
  `x<--ooo`,
  `x -- x`,
  `x -- x
  `,
  `
  x -- x`,
  `
  x -- x
  `,
  `
  x -- x
  
  `,
  `x -- y`,
  `x1 -- y`,
  ` x   --   y`,
  //allow empty lines
  `x -- y
  
  
  
  y -- x`,

  //multi line
  `x -- y
  a -- b`,

  `x -- y
  a -- b
  `,

  `x -- y
  a -- b222
  
  `,

  `x -- y
  a -- b
  a2 --> b2`,

  `a .. b`,
  `a <-- b`,
  `a <.. b`,
  `a --> b`,
  `a ..> b`,

  `a <|-- b`,
  `a <|.. b`,
  `a --|> b`,
  `a ..|> b`,

  `a *-- b`,
  `a *.. b`,
  `a --* b`,
  `a ..* b`,

  `a o-- b`,
  `a o.. b`,
  `a --o b`,
  `a ..o b`,

  //cardinality is a string enclosed in ""
  `x "*" .. y`,
  `x  -- "*" y`,
  `x --> "10" y`,
  `x "1" -- "*" y`,
  `x "100" -- "many" y`,
  `x "*" -- "*" y`,
  `x "1many1" -- "*asd*" y`,
  `x "*" .. "spaces ??? yay" y`,

  //with text
  `x -- y : "spaces allowed"`,
  `x "1" -- y : "0contains"`,
  `x "1" -- "*" y : "0contains"`,
  `x "1" -- y : "0contains"`,
  `x -- "1" y : "0contains"`,

  //with direction
  `x -- y : <`,
  `x -- y : >`,
  `x --> y : >`,
  `x <.. y : >`,

  `x --> y : "right" >`,
  `x --> y : < "left"`,

  //empty class

  `class Foo`,

  //class members

  `Foo : isOk`,
  `Foo : isOk : bool`,
  //`Foo : bool isOk`,
  `Foo : isOks : bool[]`,
  //`Foo : bool[] isOks`,
  `Bar : check()`,
  `Bar : check() : bool`,
  //`Bar : bool check()`,
  `Bar : check() : bool[]`,
  //`Bar : bool[] check()`,

  //methods with params
  `Bar : check(param1)`,
  `Bar : check(param1) : void`,
  //`Bar : void check(param1)`,

  //`Bar : check(int param1)`,
  `Bar : check(param1 : int)`,

  //`Bar : check(int param1, int param2)`,
  //`Bar : check(int param1, param2)`,
  //`Bar : check(param1, int param2)`,

  `Bar : check(param1 : int, param2 : int)`,
  `Bar : check(param1 : int, param2)`,
  `Bar : check(param1, param2 : int)`,
  //`Bar : check(param1, int param2, param2 : int)`,

  //`Bar : check(int[] param1)`,
  `Bar : check(param1 : int[])`,

  //`Bar : check(int[] param1, int[] param2)`,
  //`Bar : check(int[] param1, param2)`,
  //`Bar : check(param1, int[] param2)`,

  `Bar : check(param1 : int[], param2 : int[])`,
  `Bar : check(param1 : int[], param2)`,
  `Bar : check(param1, param2 : int[])`,
  //`Bar : check(param1, int[] param2, param2 : int[])`,

  //`Bar : check(int[][][] param1)`,
  `Bar : check(param1 : int[][][] )`,

  //`Bar : check(param1, int param2, param2 : int) : void`,
  `Bar : check(param1, param2 : string, param2 : int) : void`,
  //`Bar : void check(param1, int param2, param2 : int)`,


]

//class, properties, methods
const testsOk2: string[] = [
  `class X {
  }`
  ,
  `class X {
  }
  `
  ,
  `class X {
  
  }`
  ,
  `class X {
  
  }
  `
  ,
  `class X {
  
  
  
  }`
  ,
  `class X {
    isOk
  }`
  ,
  `class X {
    isOk : bool
  }`
  ,
  // `class X {
  //   bool isOk
  // }`
  // ,
  `class X {
    isOk : bool[]
  }`
  ,
  // `class X {
  //   bool[] isOk
  // }`
  // ,
  `class X {
    check()
  }`
  ,
  `class X {
    check() : bool
  }`
  ,
  // `class X {
  //   bool check()
  // }`
  // ,
  `class X {
    check() : bool[]
  }`
  ,
  // `class X {
  //   bool[] check()
  // }`
  // ,
  //empty lines inside class
  `class X {
    isOk
    
    
    isOk2
  }`
  ,
  `class X {
    isOk
    isOk2
  }`
  ,
  `class X {
    isOk
    isOkFunc()
  }`
  ,
  `class X {
    isOkFunc()
    isOk
  }`
  ,
  `class X {
    isOkFunc()
    isOk
    check() : bool[]
  }`
  ,
  // `class X {
  //   isOkFunc()
  //   isOk
  //   bool check()
  // }`
  // ,
  // `class X {
  //   isOkFunc()
  //   isOk
  //   bool[] check()
  // }`
  // ,
  `class X {
  }
  class Y {
  }`
  ,
  `class X {
    data : int
  }
  class Y {
    data
  }`
  ,
  // `
  // class X {
  //   isOkFunc()
  //   isOk
  //   check() : bool[]
  //   bool[] check2()
  //   bool isOk2
  // }
  // `
  // ,
  `
  class Y {
    isOk
    check2():int[]
    check2()
    isOk2 : string
    check2() : bool
  }`
  ,
  `class X {
    {field} A_field
    {method} Some_method()
  }`
  ,
  // `class X {
  //   {field} int A_field
  //   {method} int Some_method()
  // }`
  // ,
  `class X {
    {field} A_field : int
    {method} Some_method() : int
  }`
  ,
  `class X {
    {field} A_field : int
    {method} Some_method() : int[]
  }`
  ,
  `class X {
    +foo
    +foo2:int
  }`
  ,
  `class X {
    +foo2:int
    +foo3:int[]
  }`
  ,
  `class X {
    +foo()
    +foo3():int
    +foo4():int[]
  }`
  ,
  `class X {
    +foo
    -foo2:int
    ~foo3
    #foo3
    +foo()
    -foo2(p1, p2):int
    ~foo3(p1: int, p2 : int)
    #foo3(param1)
  }`
  ,
  `class X {
    + {field} foo
    + {method} foo2()
  }`
  ,
  // `class X {
  //   + {field} int foo
  //   + {method} int foo2()
  // }`
  // ,
  `class X {
    + {field} foo : int
    + {method} foo2() : int
  }`
  ,
  `class X {
    + {field} foo : int
    + {method} foo2() : int[]
  }`
  ,

  //abstract & static
  `class X {
    {static} foo
    {classifier} foo
    {abstract} foo
    
    {static} foo()
    {classifier} foo()
    {abstract} foo()
  }`
  ,
  `class X {
    + {field} foo : int
    + {method} foo2() : int[]
  }`
  ,
  `class X {
    + {static} {field} foo : int
    - {classifier} {field} foo : int
    ~ {abstract} {field} foo : int
    
    # {static} {field} foo : int[]
    + {classifier} {field} foo : int[][]
    + {abstract} {field} foo : in
   
  }`
  ,
  //stereotypes
  `class X << general >>`
  ,
  `class X <<general>> {
  }`
  ,
  `class X << general >> {
    foo
    method()
  }`
  ,
  `class X << general >> {
    foo : int
    foo() : int
  }`

]


//notes
const testsOk3: string[] = [
  //notes
  `note "this is a test"
  `
  ,
  `note "this is a test" as N1`
  ,
  `class X
  note "not connected to X"
  note "note connected to X" as Note0
  
  note "note connected to X"
  
  class Y
  
  note top of X : "connected to X"
  note left of X : "connected to X"
  note right of X : "connected to X"
  note bottom of X : "connected to X"
  
  `
  ,
  `class X
  note "not connected to X"
  note top of X : "also connected to X2"
  `
  ,
  `class X
  note top of X : "also connected to X"`
  ,
  `class X
  note top : "connected to X"
  
  class Y
  note left : "connected to Y"
  note top of X : "also connected to X"
  
  `
  ,
  `
  class X
  note "xxx" as N1
  note "yyy" as N2
  N1 .. X
  X .. N2
  `,
  `
  note "row 1
  row 2
  row3
  
  row 5"
  `,
  `
  class Dummy
  Dummy --> Foo : "A link"
  note on link: "note that is red"
  `
  ,
  `Dummy --> Foo : "A link"
  note on link: "black is default color?"
  `
  ,
  `Dummy --> Foo : "A link"
  note on link: "black is default color?"
  `
  ,
  `Dummy --> Foo : "A link"
   note top on link: "black is default color?"
   note bottom on link: "black is default color?"
   note left on link: "black is default color?"
   note right on link: "black is default color?"
  `
  ,


]


//abstract class, interfaces, enums,
//renaming classes
const testsOk4: string[] = [
  `abstract class AbstractList`
  ,
  `abstract class AbstractList
  `
  ,
  `
  abstract class AbstractList`
  ,
  `
  abstract class AbstractList
  `
  ,
  `abstract AbstractCollection
  `
  ,
  `abstract AbstractCollection {
  }
  `
  ,
  `abstract class AbstractList {
    foo() : void
  }
  `
  ,
  `abstract class AbstractCollection {
  }
  `,
  `abstract class AbstractCollection as "Display Text" {
  }
  `,
  `abstract class "Display Text" as AbstractCollection  {
  }
  `,
  `interface IList`,
  `interface IList {
  }`
  ,
  `interface IList {
  
  }`
  ,
  `interface IList {
    method()
  }`
  ,
  `interface IList {
  
    method()
  }`,
  `interface IList {
    method() : void
    
  }`
  ,
  `interface IList <<stereotype>>`
  ,
  `interface IList <<stereotype>> {
  
    method(arg1) : void
    
  }`,
  //enums
  `enum Uni`,
  `enum Uni {
  }`
  ,
  `enum Uni {
  
  }`
  ,
  `enum MEMBER_ENUM {
    method
    field
  }`
  ,
  `enum Uni {
  
    KM
    m
    dc
    
    cm
    
  }`,
  `enum Uni {
    EUR
    DOLLAR
    
  }`
  ,
  `enum Uni <<stereotype_int>> {
  
     S
     
     ms
    
  }`
  ,
  `enum Uni <<stereotype_int>> {
     s = 0
     ms = 1
  }`
  ,
  `enum Uni <<stereotype_int>> {
     s = 0
     ms = "ms"
  }`,
  //(re)naming classes
  `class " This is my class" as class1`
  ,
  `class class2 as " It works this way too"`
  ,
  `class " This is my class" as class1 << test >> {
    foo : int
  }`
  ,
  `class class2 as " It works this way too" << test >> {
    foo : int
  }`
  ,
  `interface " This is my interface" as interface1`
  ,
  `interface interface2 as " It works this way too"`
  ,
  `interface " This is my interface" as interface1 << test >> {
    foo() : void
  }`
  ,
  `interface interface2 as " It works this way too" << test >> {
    foo() : void
  }`
  ,
  `enum " This is my enum" as enum1`
  ,
  `enum enum2 as " It works this way too"`
  ,
  `enum " This is my enum" as enum1 << test >> {
    DAY
    MONTH
    YEAR
  }`
  ,
  `enum enum2 as " It works this way too" << test >> {
  
    DAY
    MONTH
    YEAR
    
  }`
  ,

]

//class generics
const testsOk5: string[] = [

  `class X {
    bar<T>(x) : bool
  }`
  ,
  `class X {
    +bar<T>(x: T, y : T) : bool
  }`
  ,
  `class X {
    +bar<T : String>(x: T, y) : bool
  }`
  ,
  `class X {
    +bar<T : int[]>(x: T, y : T) : bool
  }`
  ,
  `class X {
    -bar<T, T2 : IEnumerator>(x: T, y) : T2
  }`
  ,
  `class X {
    bar<T : Tuple<String>>()
  }`
  ,
  `class X {
    -bar<T, T2 : Tuple<int, int, string>>(x: T, y) : T2
  }`
  ,
  `class X {
    -bar<T, T2 : Tuple<int, int, Pair<int, int[]> >>(x: T, y : T) : T2
  }`
  ,
  `class X {
    -bar<T : int, T2 : T>(x: T, y : T) : T2
  }`
  ,
  //java wildcard
  `class X {
    -bar<? : Element>(x: T, y) : T2
  }`
  ,
  `class X {
    -bar<?, T2>(x: T, y) : T2
  }`
  ,

  `class X {
    -bar<T1 : Pair<int, string>[]>(x: T, y) : T2
  }`
  ,
  //class level generics
  `class Foo<? : Element, T2>`
  ,
  `class Foo<? : Element, T2 : Pair<int, string[], List<int>>>`
  ,
  `class Foo<? : Element, T2 : Pair<int, string[], List<int>>> {
  }`
  ,
  `class Foo<? : Element, T2> {
    +test<T, T2>(p1 : T, p2: T2)
  }`

  ,
  //with stereotype
  `class Foo<? : Element, T2> << stereotype >>`
  ,
  `class Foo<? : Element, T2> << stereotype >> {
    foo() : void
  }`
  ,
  `class "display Text" as Foo<? : Element, T2> {
    foo() : void
  }`
  ,
  `class "display Text" as Foo<? : Element, T2> <<FactoryStereotype>> {
    foo() : void
  }`
  ,
  `class Foo<? : Element, T2> as "display Text" {
    foo() : void
  }`
  ,
  `class Foo<? : Element, T2 : List<string>> as "display Text" << stereotype >> {
    foo() : void
  }`
  ,
  `class CollectionHelper <<static>> {
      map<TIn, TOut>(array : Tin[]) : TOut[]
      filter<T>(array : T[] , predicate : Func<T, bool>) : T[]
    }
  `
  ,
  `class Tuple<T1 : Pair<int, string>[]>`
  ,
  //lets go crazy ;)
  //from the readme
  `class Tuple<T1, T2 : Tuple3<int, string[], List<int>, Pair<string,long>[]>>`,
  "class Tuple<?, T2 : Tuple3<int, string[], List<int>, Pair<int,long>[]>>",

  //class level and method
  `
  class List<T> {
    +test<T, T2>(p1 : T, p2: T2)
    -test<T, T2 : int>(p1 : T, p2: T2 )
    test<T, T2, T3>(p1 : T, p2: T2 ) : T3
    test<T>(p1 : T) : T
    map<TIn, TOut>(array : Tin[]) : TOut[]
  }
`,
  `
  class List<T, T2> {
    +data : T
    data : T2
  }
`
  ,

]

//interface generics
const testsOk6: string[] = [

  `interface X {
    bar<T>(x: T, y: T) : bool
  }`
  ,
  `interface X {
    bar<T : String>(x: T,y) : bool
  }`
  ,
  `interface X {
    bar<T : int[]>(x: T, y) : bool
  }`
  ,
  `interface X {
    bar<T, T2 : IEnumerator>(x: T, y) : T2
  }`
  ,
  `interface X {
    bar<T : Tuple<String>>()
  }`
  ,
  `interface X {
    bar<T, T2 : Tuple<int, int, string>>(x: T,  y) : T2
  }`
  ,
  `interface X {
    bar<T, T2 : Tuple<int, int, Pair<int, int[]> >>(x: T, y) : T2
  }`
  ,
  `interface X {
    bar<T : int, T2 : T>(x: T,  y) : T2
  }`
  ,
  //java wildcard
  `interface X {
    bar<? : Element>(x: T,  y) : T2
  }`
  ,
  `interface X {
    bar<?, T2>(x: T,  y) : T2
  }`
  ,

  `interface X {
    bar<T1 : Pair<int, string>[]>(x: T,  y) : T2
  }`
  ,
  //class level generics
  `interface Foo<? : Element, T2>`
  ,
  `interface Foo<? : Element, T2 : Pair<int, string[], List<int>>>`
  ,
  `interface Foo<? : Element, T2 : Pair<int, string[], List<int>>> {
  }`
  ,
  `interface Foo<? : Element, T2> {
    test<T, T2>(p1 : T, p2)
  }`

  ,
  //with stereotype
  `interface Foo<? : Element, T2> << stereotype >>`
  ,
  `interface Foo<? : Element, T2> << stereotype >> {
    foo() : void
  }`
  ,
  `interface "display Text" as Foo<? : Element, T2> {
    foo() : void
  }`
  ,
  `interface "display Text" as Foo<? : Element, T2> <<FactoryStereotype>> {
    foo() : void
  }`
  ,
  `interface Foo<? : Element, T2> as "display Text" {
    foo() : void
  }`
  ,
  `interface Foo<? : Element, T2 : List<string>> as "display Text" << stereotype >> {
    foo() : void
  }`
  ,
  `interface CollectionHelper <<static>> {
      map<TIn, TOut>(array : Tin[]) : TOut[]
      filter<T>(array : T[], predicate : Func<T, bool>) : T[]
    }
  `
  ,
  `interface Tuple<T1 : Pair<int, string>[]>`
  ,
  //lets go crazy ;)
  //from the readme
  `interface Tuple<T1, T2 : Tuple3<int, string[], List<int>, Pair<string,long>[]>>`,
  "interface Tuple<?, T2 : Tuple3<int, string[], List<int>, Pair<int,long>[]>>",

  //class level and method
  `
  interface List<T> {
    test<T, T2>(p1 : T, p2)
    test<T, T2 : int>(p1 : T, p2)
    test<T, T2, T3>(p1 : T, p2) : T3
    test<T>(p1 : T) : T
    map<TIn, TOut>(array : Tin[]) : TOut[]
  }
`
  ,
  `interface Java8Predicate<T> {
    test(t : T) : boolean
    negate1() : Java8Predicate<T>     
    negate6() : Java8Predicate<T>
    negate7<T2>() : Java8Predicate<T>
    negate9<T2>() : Java8Predicate<?, T2>
    negate10() : Java8Predicate<?, T2>
  }
  `
  ,
  //works because we simply ignore/skip {field}, {method}
  `interface Java8Predicate<T> {
    and(other) : Java8Predicate<T>
    or(other : Java8Predicate<?>) : Java8Predicate<T>
    isEqual(targetRef : Object) : Java8Predicate<T>
    isEqual(targetRef:Object) : Java8Predicate<T, T2>
    {field} keywordFieldIsIgnored(targetRef:Object) : Java8Predicate<T, T2>
    {method} keywordMethodIsIgnored(targetRef:Object) : Java8Predicate<T, T2>
  }
  `

]

//packages
const testsOk7: string[] = [
  `package foo {
  }`,
  `package foo1::foo2 {
  }`
  ,
  `package foo1 {
    class X
  }`
  ,
  `package foo1::foo2::Foo3 {
    class X
  }`,

  `package foo1::foo2::Foo3 {
  
    class X
    
    class X
    
  }`,
  `package foo1::foo2::Foo3 {
    class X
    class X
    
  }`
  ,
  `package foo1::foo2::Foo3 {
    
    class X
    class X
  }`
  ,
  `package foo1::foo2::Foo3 {
    
    class X
    class Y {
    }
  }`,

  `package foo1::foo2::Foo3 {
    
    class X
    class Y<T> {
      data1
      data2 : T
    }
  }`,

  `package foo1::foo2::Foo3 {

    class X
    class Y<T> {
      data1
      data2 : T
    }
    interface X2
    interface X25 {
    }
    interface X3 {
      check()
      check(): bool
    }
  }`
  ,
  `package foo1::foo2::Foo3 {

    class X
    class Y<T> {
      data1
      data2 : T
    }
    interface X2
    interface X3 {
      check()
      check(): bool
    }
    enum Unit
    enum Unit2 {
    }
    enum Unit2 {
      A = 1
      B = 2
      C = 4
    }
    enum Unit3 << string>> {
      A = "a"
      B = "b"
      C = "c"
    }
  }`
  ,
  `
  package foo1 {
    class T1  
    package foo2::foo3 {
    
      package foo4 {
      }
      
      package foo5 << aNode >> {
        interface Test
      }
    }
    
    class Math {
      {static} PI : double
    }
  }
  `
  ,
  `
  class X1::X2::foo {
   count
  }
  
  enum X1::X2::foo {
   count
  }
  interface X1::X2::foo {
   count()
  }
  `,

  `
  package foo1::foo2::foo3 {
  }
  package foo1 {
    class X
    package foo2 {
      class Nested<T>
    }
  }
  `
  ,
  `
  X1::X2::foo::Class1 -- X1::X2::Class2
  `
  ,
  `
  class List<T : foo::Item> {
  }
  `

]

//association class
const testsOk8: string[] = [
  `
  Student " 0..*" -- " 1..*" Course
  (Student, Course) .. Enrollment
  `
  ,
  `
  Student " 0..*" -- " 1..*" Course
  (Student, Course) .. foo::Enrollment
  
  class foo::Enrollment { 
    drop() 
    cancel() 
  }
  `
]

//comments
const testsOk9: string[] = [
  ``,
  `
  `
  ,
  ` /* */
  `
  ,
  `/**/`
  ,
  `class X //comment`,

  `class X
  //comment
  `,
  `class X /* comment */`,
  `class X /* comment 
  */`,
  `/* comment */`,
  `/* comment 
  */`,
  `/**
     * xxx
     */`,

  `/**
     *
    ***/`,
  `
  class /* very */ Important /* multi
    line
    comment
    */
  `,
  `
  class X /* // comment inside comment */
  `
  ,
  `
  class X // /* comment inside comment */
  `
  ,

  `
  class X /* nl
  */
  class X { /* nl
  class Y */
  }
  `
  ,
  `
  class X { /* nl
  class Y 
  */
  }
  `
  ,
  `
  class X { /* nl
  class Y 
  */
  } /* 
  */
  `,
  `
  X -- Y : " //no comment but a string"
  `
  ,
  `
   X --  Y : " /*no comment*/"
  `
  ,
  `
   X --  Y : " /*no comment
  but a 
  string
  */"
  `,

  `
   X --  Y : " /* should be /* just one comment*/"
  `
  ,
  `
   X --  Y : " /* should be /* 
  just one comment
  */"
  `
  ,
  `
  class X // /* should work
   `
  ,
  `
  class X //  should work */
   `
  ,
]

//relation end names
const testsOk10: string[] = [
  `X "*" : "name" -- "*" Y`,
  `X "*" -- "*" : "name" Y`,
  `X "*": "name" -- "*" : "name" Y`,

  `X "*" : "name" -- "*" Y : "some relation"`,
  `X "*" -- "*" : "name" Y : "some relation"`,
  `X "*": "name" -- "*" : "name" Y : "some relation"`,

  `X  "*" : + "name" -- "*" Y`,
  `X "*" -- "*" : + "name" Y`,
  `X "*": + "name" -- "*" : + "name" Y`,

  `X "*" : - "name" -- "*" Y : "some relation"`,
  `X "*" -- "*" : # "name" Y : "some relation"`,
  `X "*": +"name" -- "*" : +"name" Y : "some relation"`,
]

//should fail
const testsFail: string[] = [
  `1x-- y`,
  `x - -y`,
  `x-- - y`,
  //not supported yet
  `a < -- * b`,
  `
a {--b`,
  `
  
a *--> b`,
  `
  a-- + b`,
  `
  a-- ^ b`,

  `
  x-- > y
: >
  right`, //not allowed
  `
  x--
  y : left < `, //not allowed

  `
  Bar : void check(int
  param1
)
  void`, //two method result types
  `
  Bar : void check(int
  param1
) :
  void`, //two method result types

  `

  class as

  `,
  `

  class Foo

  tooMuch`
  ,
  `

  class X << general xxx >> ` //only text allowed (no whitespace)
  ,
  //interface members are always implicite public
  `interface IList {
    +method()
    -method()
    ~method()
    #method()
  }`
  ,
  //interfaces have no fields...
  `interface IList {
    +field
    -field
    ~field
    #field
  }`,
  `class Foo <<stereotype>> <? : Element, T2>`
  ,
  //if we place a generic type we cannot restrict it because we use a type and not defining a new parameter
  `interface Java8Predicate<T> {
    negate6() : Java8Predicate<T : int>
  }
  `
  ,
  //because old syntax
  `
  class X {
    Java8Predicate<T> negate3<T2>()
  }
  `
  ,
  //old syntax + wrong generic usage
  `
  class X {
    Java8Predicate<T : int> negate3<T2>()
  }
  `
  ,
  //interface cannot have fields
  `interface X {
    foo
  }
  `
  ,
  //interface cannot have modifiers
  `interface X {
    +isEqual()
  }
  `
  ,
  `interface X {
    {static} isEqual()
  }
  `
  ,
  `interface X {
    + {static} isEqual()
  }
  `
  ,
  `package foo`
  ,
  `
  class X // /* should be an error
   */
  `
]


// testsOk0.forEach(prog => {
//   displayTestResult(runTest(prog))
// })

// testsOk.forEach(prog => {
//   displayTestResult(runTest(prog))
// })
// //
// testsOk2.forEach(prog => {
//   displayTestResult(runTest(prog))
// })
//
// testsOk3.forEach(prog => {
//   displayTestResult(runTest(prog))
// })
//
// testsOk4.forEach(prog => {
//   displayTestResult(runTest(prog))
// })
//
// testsOk5.forEach(prog => {
//   displayTestResult(runTest(prog))
// })
//
// testsOk6.forEach(prog => {
//   displayTestResult(runTest(prog))
// })
//
// testsOk7.forEach(prog => {
//   displayTestResult(runTest(prog))
// })
//
// testsOk8.forEach(prog => {
//   displayTestResult(runTest(prog))
// })
//
// testsOk9.forEach(prog => {
//   displayTestResult(runTest(prog))
// })

testsOk10.forEach(prog => {
  displayTestResult(runTest(prog))
})

// testsFail.forEach(prog => {
//   displayTestResult(runTest(prog))
// })

// document.write("tests ran:")
// document.write(count)