/**
 * Created by janis dähne.
 */



interface Class extends ThingInsideContainer, Aliasable, Entity {

  otherModifier: OtherModifier | null

  stereotype: string | null
  properties: Property[]
  methods: Method[]

  /**
   * e.g. List<T> {}
   */
  genericsDefinitions: GenericsDefinition[]
}

interface Property {
  name_pk: string
  type: Type | null

  visibilityModifier: VisibilityModifier | null
  otherModifier: OtherModifier | null
}

interface Method extends InterfaceMethod {

  visibilityModifier: VisibilityModifier | null
  otherModifier: OtherModifier | null
}