/**
 * Created by janis dähne.
 */


interface Interface extends ThingInsideContainer, Aliasable, Entity {
  stereotype: string | null
  methods: InterfaceMethod[]

  /**
   * e.g. interface IEnumerable<T>
   */
  genericsDefinitions: GenericsDefinition[]
}

/**
 * we could use Method from classes but we want to be more type safe
 */
interface InterfaceMethod {
  name_pk: string
  parameters: Property[]
  returnType: Type | null

  genericsDefinitions: GenericsDefinition[]
}