/**
 * Created by janis dähne.
 */



interface Package extends Entity, PackageShaped {
  name_pk: string
  parentPackage: Package | null

  stereotype: string | null

  classes: Class[]
  interfaces: Interface[]
  enums: Enumeration[]

  /**
   * actually this will be empty because relations are currently only
   * valid in to model not in packages and association classes can only be specified directly after the relation...
   */
  associationClasses: AssociationClass[]

  subPackages: Package[]

}

/*
interface Namespace extends Entity {
  name_pk: string
  parentNamespace: Namespace | null

  classes: Class[]
  interfaces: Interface[]
  enums: Enumeration[]

  subNamespace: Namespace[]
}
*/