/**
 * Created by janis dähne.
 */


class NoteBuilder {

  static createNote(text: string,
                    //displayName: string | null = null,
                    alias: string | null = null,
                    forRelationId: number | null = null): Note {
    return {
      text,
      //displayName,
      alias,
      forRelationId
    }
  }

  static setText(target: Note, text: string): Note {
    set(target, 'text', text)
    return target
  }

  static setRelationId(target: Note, forRelationId: number): Note {
    set(target, 'forRelationId', forRelationId)
    return target
  }

  // static setDisplayName(target: Note, displayName: string): Note {
  //   target.displayName = displayName
  //   return target
  // }

  static setAlias(target: Note, alias: string): Note {
    set(target, 'alias', alias)
    return target
  }
}