/**
 * Created by janis dähne.
 */


class TypeBuilder {
  static createType(name: string, arrayDimension: number | null = null, appliedGenerics: Type[] = []): Type {
    return {
      name_pk: name,
      arrayDimension,
      appliedGenerics
    }
  }

  static addAppliedGenericDefinition(target: Type, definition: Type): Type {
    target.appliedGenerics.push(definition)
    return target
  }

  static addManyAppliedGenericDefinitions(target: Type, definitions: Type[]): Type {
    target.appliedGenerics = target.appliedGenerics.concat(definitions)
    return target
  }

}