/**
 * Created by janis dähne.
 */


var fs = require('fs');

var pumclJSON = null //= require('./pumcl.json')

if (process.argv.length < 3) {
    console.log('NO ARGS!! specify the json ebnf file')
}

//console.log(process.argv)


fs.readFile(process.argv[2], 'utf8', function (err,data) {
  if (err) {
    return console.log(err);
  }
  pumclJSON = data


  var parsedPumclEBNF = JSON.parse(pumclJSON)

  var grammar = ''

  for(var key in parsedPumclEBNF.bnf) {
    var rule = parsedPumclEBNF.bnf[key]

    if (key == 'start') {
      grammar += key + " ::= " + rule[0][0] + '\n'
      //grammar += key + " ::= " + 'statements' + '\n'
    } else {
      grammar += key + " ::= " + rule.join(' | ') + ' \n'
    }
  }

  fs.writeFile("pumcl.ebnf", grammar, function(err) {
    if(err) {
      return console.log(err);
    }
    console.log("The file was saved!");
  });

});







